#define int8 char		/* 8-bit integer */
#define int16 short		/* 16-bit integer */
#define int32 long		/* 32-bit integer */

typedef char *Ptr;		/* pointer */
typedef Ptr *Handle;		/* handle */
typedef int16 (*ProcPtr)();	/* pointer to procedure returning int16 */
typedef ProcPtr *ProcHandle;	/* handle to procedure returning int16 */

#define String(size) struct {unsigned char length; char text[size];}
typedef String(255) Str255;	/* maximum length pascal string */
typedef Str255 *StringPtr;	/* pointer to maximum length pascal string */
typedef StringPtr *StringHandle;	/* handle to maximum length pascal string */

typedef int16 OSErr;		/* operating system error code */
typedef int32 OSType;		/* operating system type code */
typedef Ptr QElemPtr;		/* pointer to queue element */

#define FCBLen *((int16 *) 0x3f6)	/* MFS == -1, HFS == length of FCB */
#define mfsSigWord 0xd2d7	/* MFS volume signature */
#define hfsSigWord 0x4244	/* HFS volume signature */
#define rootDirID 2		/* HFS root volume directory id */
#define ioDirFlg 0x10		/* catalog node directory flag */

typedef struct 
	{
	OSType fdType;		/* file's type */
	OSType fdCreator;	/* file's creator */
	int16 fdFlags;		/* flags */
	int16 fdLocation[2];	/* file's location */
	int16 fdFldr;		/* file's window */
	} FInfo, *FInfoPtr;

typedef struct
	{
	QElemPtr qLink;		/* next queue entry */
	int16 qType;		/* queue entry type */
	int16 ioTrap;		/* routine trap */
	Ptr ioCmdAddr;		/* routine address */
	ProcPtr ioCompletion;	/* completion routine */
	OSErr ioResult;		/* result code */
	StringPtr ioNamePtr;	/* name */
	int16 ioVRefNum;	/* reference number */
	int16 ioRefNum;		/* path reference number */
	int8 ioVersNum;		/* version number */
	int8 ioPermssn;		/* read/write permission */
	Ptr ioMisc;		/* miscellaneous */
	Ptr ioBuffer;		/* data buffer */
	int32 ioReqCount;	/* requested number of bytes */
	int32 ioActCount;	/* actual number of bytes */
	int16 ioPosMode;	/* positioning mode and newline */
	int32 ioPosOffset;	/* positioning offset */
	} IOParam, *IOParamPtr;

typedef struct
	{
	QElemPtr qLink;		/* next queue entry */
	int16 qType;		/* queue entry type */
	int16 ioTrap;		/* routine trap */
	Ptr ioCmdAddr;		/* routine address */
	ProcPtr ioCompletion;	/* completion routine */
	OSErr ioResult;		/* result code */
	StringPtr ioNamePtr;	/* name */
	int16 ioVRefNum;	/* reference number */
	int16 ioFRefNum;	/* path reference number */
	int8 ioFVersNum;	/* version number */
	int8 filler1;		/* unused */
	int16 ioFDirIndex;	/* sequence number */
	int8 ioFlAttrib;	/* attributes */
	int8 ioFlVersNum;	/* version number */
	FInfo ioFlFndrInfo;	/* finder information */
	int32 ioFlNum;		/* file number */
	int16 ioFlStBlk;	/* first allocation block of data fork */
	int32 ioFlLgLen;	/* logical end-of-file of data fork */
	int32 ioFlPyLen;	/* physical end-of-file of data fork */
	int16 ioFlRStBlk;	/* first allocation block of resource fork */
	int32 ioFlRLgLen;	/* logical end-of-file of resource fork */
	int32 ioFlRPyLen;	/* physical end-of-file of resource fork */
	int32 ioFlCrDat;	/* creation date */
	int32 ioFlMdDat;	/* modification date */
	} FileParam, *FileParamPtr;

typedef struct
	{
	QElemPtr qLink;		/* next queue entry */
	int16 qType;		/* queue entry type */
	int16 ioTrap;		/* routine trap */
	Ptr ioCmdAddr;		/* routine address */
	ProcPtr ioCompletion;	/* completion routine */
	OSErr ioResult;		/* result code */
	StringPtr ioNamePtr;	/* name */
	int16 ioVRefNum;	/* reference number */
	int32 filler2;		/* unused */
	int16 ioVolIndex;	/* volume index */
	int32 ioVCrDate;	/* creation time and date */
	int32 ioVLsBkUp;	/* last backup time and date */
	int16 ioVAtrb;		/* attributes */
	int16 ioVNmFls;		/* number of files in directory */
	int16 ioVDirSt;		/* first block of directory */
	int16 ioVBlLn;		/* length of directory in blocks */
	int16 ioVNmAlBlks;	/* number of allocation blocks */
	int32 ioVAlBlkSiz;	/* size of allocation block */
	int32 ioVClpSiz;	/* number of bytes to allocate */
	int16 ioAlBlSt;		/* first allocation block in map */
	int32 ioVNxtFNum;	/* next unused file number */
	int16 ioVFrBlk;		/* number of unused allocation blocks */
	} VolumeParam, *VolumeParamPtr;

typedef struct
	{
	QElemPtr qLink;		/* next queue entry */
	int16 qType;		/* queue entry type */
	int16 ioTrap;		/* routine trap */
	Ptr ioCmdAddr;		/* routine address */
	ProcPtr ioCompletion;	/* completion routine */
	OSErr ioResult;		/* result code */
	StringPtr ioNamePtr;	/* name */
	int16 ioVRefNum;	/* reference number */
	int16 ioRefNum;		/* path reference number */
	int16 filler;		/* unused */
	int32 ioFCBIndx;	/* fcb index for _getfcbinfo */
	int32 ioFCBFlNm;	/* file number */
	int16 ioFCBFlags;	/* flags */
	int16 ioFCBStBlk;	/* first allocation block of file */
	int32 ioFCBEOF;		/* logical end-of-file */
	int32 ioFCBPLen;	/* physical end-of-file */
	int32 ioFCBCrPs;	/* mark */
	int16 ioFCBVRefNum;	/* volume reference number */
	int32 ioFCBClpSiz;	/* file clump size */
	int32 ioFCBParID;	/* parent directory id */
	} FCBParam, *FCBParamPtr;

typedef struct
	{
	QElemPtr qLink;		/* next queue entry */
	int16 qType;		/* queue entry type */
	int16 ioTrap;		/* routine trap */
	Ptr ioCmdAddr;		/* routine address */
	ProcPtr ioCompletion;	/* completion routine */
	OSErr ioResult;		/* result code */
	StringPtr ioNamePtr;	/* name */
	int16 ioVRefNum;	/* reference number */
	int16 ioRefNum;		/* path reference number */
	int8 ioVersNum;		/* version number */
	int8 ioPermssn;		/* read/write permission */
	Ptr ioMisc;		/* miscellaneous */
	Ptr ioBuffer;		/* data buffer */
	int32 ioReqCount;	/* requested number of bytes */
	int32 ioActCount;	/* actual number of bytes */
	int32 filler;		/* unused */
	int32 ioDirID;		/* directory id */
	} HIOParam, *HIOParamPtr;

typedef struct
	{
	QElemPtr qLink;		/* next queue entry */
	int16 qType;		/* queue entry type */
	int16 ioTrap;		/* routine trap */
	Ptr ioCmdAddr;		/* routine address */
	ProcPtr ioCompletion;	/* completion routine */
	OSErr ioResult;		/* result code */
	StringPtr ioNamePtr;	/* name */
	int16 ioVRefNum;	/* reference number */
	int16 ioFRefNum;	/* path reference number */
	int16 filler2;		/* unused */
	int16 ioFDirIndex;	/* sequence number of file */
	int8 ioFlAttrib;	/* attributes */
	int8 filler3;		/* version number */
	FInfo ioFlFndrInfo;	/* finder information */
	int32 ioDirID;		/* directory id */
	int16 ioFlStBlk;	/* first allocation block of data fork */
	int32 ioFlLgLen;	/* logical end-of-file of data fork */
	int32 ioFlPyLen;	/* physical end-of-file of data fork */
	int16 ioFlRStBlk; 	/* first allocation block of resource fork */
	int32 ioFlRLgLen;	/* logical end-of-file of resource fork */
	int32 ioFlRPyLen;	/* physical end-of-file of resource fork */
	int32 ioFlCrDat;	/* creation time and date */
	int32 ioFlMdDat;	/* modification time and date */
	} HFileParam, *HFileParamPtr;

typedef struct
	{
	QElemPtr qLink;		/* next queue entry */
	int16 qType;		/* queue entry type */
	int16 ioTrap;		/* routine trap */
	Ptr ioCmdAddr;		/* routine address */
	ProcPtr ioCompletion;	/* completion routine */
	OSErr ioResult;		/* result code */
	StringPtr ioNamePtr;	/* name */
	int16 ioVRefNum;	/* reference number */
	int32 filler4;		/* unused */
	int16 ioVolIndex;	/* volume index */
	int32 ioVCrDate;	/* creation time and date */
	int32 ioVLsMod;		/* modification time and date */
	int16 ioVAtrb;		/* attributes */
	int16 ioVNmFls;		/* number of files in directory */
	int16 ioVBitMap;	/* first block of volume bitmap */
	int16 ioVAllocPtr;	/* volume space allocation pointer */
	int16 ioVNmAlBlks;	/* number of allocation blocks */
	int32 ioVAlBlkSiz;	/* size of allocation block */
	int32 ioVClpSiz;	/* default clump size */
	int16 ioAlBlSt;		/* first block in block map */
	int32 ioVNxtFNum;	/* next free node id */
	int16 ioVFrBlk;		/* number of unused allocation blocks */
	int16 ioVSigWord;	/* volume signature */
	int16 ioVDrvInfo;	/* drive number */
	int16 ioVDRefNum;	/* driver reference number */
	int16 ioVFSID;		/* file system identifier */
	int32 ioVBkUp;		/* last backup time and date */
	int16 ioVSeqNum;	/* sequence number in backup set */
	int32 ioVWrCnt;		/* volume write count */
	int32 ioVFilCnt;	/* number of files on volume */
	int32 ioVDirCnt;	/* number of directories on volume */
	int32 ioVFndrInfo[8];	/* finder information */
	} HVolumeParam, *HVolumeParamPtr;

typedef struct
	{
	QElemPtr qLink;		/* next queue entry */
	int16 qType;		/* queue entry type */
	int16 ioTrap;		/* routine trap */
	Ptr ioCmdAddr;		/* routine address */
	ProcPtr ioCompletion;	/* completion routine */
	OSErr ioResult;		/* result code */
	StringPtr ioNamePtr;	/* name */
	int16 ioVRefNum;	/* reference number */
	int16 ioFRefNum;	/* file reference number */
	int16 filler1;		/* unused */
	int16 ioFDirIndex;	/* file directory index */
	int8 ioFlAttrib;	/* attributes */
	int8 filler2;		/* unused */
	FInfo ioFlFndrInfo;	/* finder information */
	int32 ioFlNum;		/* file number */
	int16 ioFlStBlk;	/* first allocation block of data fork */
	int32 ioFlLgLen;	/* logical end-of-file of data fork */
	int32 ioFlPyLen;	/* physical end-of-file of data fork */
	int16 ioFlRStBlk; 	/* first allocation block of resource fork */
	int32 ioFlRLgLen; 	/* logical end-of-file of resource fork */
	int32 ioFlRPyLen; 	/* physical end-of-file of resource fork */
	int32 ioFlCrDat;	/* creation time and date */
	int32 ioFlMdDat;	/* modification time and date */
	int32 ioFlBkDat;	/* last backup time and date */
	FInfo ioFlXFndrInfo;	/* additional finder information */
	int32 ioFlParID;	/* parent directory id */
	int32 ioFlClpSiz;	/* file's clump size */
	} HFileInfoParam, *HFileInfoParamPtr;

typedef struct
	{
	QElemPtr qLink;	/* next queue entry */
	int16 qType;		/* queue entry type */
	int16 ioTrap;		/* routine trap */
	Ptr ioCmdAddr;		/* routine address */
	ProcPtr ioCompletion;	/* completion routine */
	OSErr ioResult;		/* result code */
	StringPtr ioNamePtr;	/* name */
	int16 ioVRefNum;	/* reference number */
	int16 ioFRefNum;	/* file reference number */
	int16 filler1;		/* unused */
	int16 ioFDirIndex;	/* file directory index */
	int8 ioFlAttrib;	/* attributes */
	int8 filler2;		/* unused */
	int16 ioDrUsrWds[8];	/* directory's user info */
	int32 ioDrDirID;	/* directory id */
	int16 ioDrNmFls;	/* number of files in directory */
	int16 filler3[9];	/* unused */
	int32 ioDrCrDat;	/* creation time and date */
	int32 ioDrMdDat;	/* modification time and date */
	int32 ioDrBkDat;	/* last backup time and date */
	int16 ioDrFndrInfo[8];	/* finder information */
	int32 ioDrParID;	/* parent id */
	int32 filler4;		/* unused */
	} DirInfoParam, *DirInfoParamPtr;

typedef struct
	{
	QElemPtr qLink;		/* next queue entry */
	int16 qType;		/* queue entry type */
	int16 ioTrap;		/* routine trap */
	Ptr ioCmdAddr;		/* routine address */
	ProcPtr ioCompletion;	/* completion routine */
	OSErr ioResult;		/* result code */
	StringPtr ioNamePtr;	/* name */
	int16 ioVRefNum;	/* reference number */
	int32 filler1;		/* unused */
	StringPtr ioNewName;	/* new name */
	int32 filler2;		/* unused */
	int32 ioNewDirID;	/* new directory id */
	int32 filler3[2];	/* unused */
	int32 ioDirID;		/* directory id */
	} CMoveParam, *CMoveParamPtr;

typedef struct
	{
	QElemPtr qLink;		/* next queue entry */
	int16 qType;		/* queue entry type */
	int16 ioTrap;		/* routine trap */
	Ptr ioCmdAddr;		/* routine address */
	ProcPtr ioCompletion;	/* completion routine */
	OSErr ioResult;		/* result code */
	StringPtr ioNamePtr;	/* name */
	int16 ioVRefNum;	/* reference number */
	int16 filler1;		/* unused */
	int16 ioWDIndex;	/* working directory index */
	int32 ioWDProcID;	/* working directory's id */
	int16 ioWDVRefNum;	/* working directory's volume reference number */
	int16 filler2[7];	/* unused */
	int32 ioWDDirID;	/* working directory's directory id */
	} WDParam, *WDParamPtr;

